/[gentoo-x86]/eclass/kde4-meta.eclass
Gentoo

Diff of /eclass/kde4-meta.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.10 Revision 1.18
1# Copyright 1999-2008 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.10 2009/01/12 19:40:34 scarabeus Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.18 2009/05/09 13:23:15 scarabeus Exp $
4# 4#
5# @ECLASS: kde4-meta.eclass 5# @ECLASS: kde4-meta.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: Eclass for writing "split" KDE packages. 8# @BLURB: Eclass for writing "split" KDE packages.
10# This eclass provides all necessary functions for writing split KDE ebuilds. 10# This eclass provides all necessary functions for writing split KDE ebuilds.
11# 11#
12# You must define KMNAME to use this eclass, and do so before inheriting it. All other variables are optional. 12# You must define KMNAME to use this eclass, and do so before inheriting it. All other variables are optional.
13# Do not include the same item in more than one of KMMODULE, KMMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY. 13# Do not include the same item in more than one of KMMODULE, KMMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY.
14 14
15# we want opengl optional in each koffice package
16if [[ $KMNAME = koffice ]]; then
17 case ${PN} in
18 koffice-data)
19 ;;
20 *)
21 OPENGL_REQUIRED=optional
22 ;;
23 esac
24fi
25
26inherit kde4-base versionator 15inherit kde4-base versionator
27 16
28EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_postinst pkg_postrm 17EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_postinst pkg_postrm
29 18
30if [[ -z ${KMNAME} ]]; then 19if [[ -z ${KMNAME} ]]; then
40 HOMEPAGE="http://www.koffice.org/" 29 HOMEPAGE="http://www.koffice.org/"
41 LICENSE="GPL-2" 30 LICENSE="GPL-2"
42 ;; 31 ;;
43esac 32esac
44 33
34# Add khelpcenter dependency when installing
35if [[ ${PN} != khelpcenter ]] && has doc ${IUSE//+} && use doc; then
36 RDEPEND="${RDEPEND}
37 >=kde-base/khelpcenter-${PV}:${SLOT}[kdeprefix=]
38 "
39fi
40
45# Add dependencies that all packages in a certain module share. 41# Add dependencies that all packages in a certain module share.
46case ${KMNAME} in 42case ${KMNAME} in
47 kdebase|kdebase-workspace|kdebase-runtime) 43 kdebase|kdebase-apps|kdebase-workspace|kdebase-runtime|kdegraphic)
44 DEPEND="${DEPEND}
48 DEPEND="${DEPEND} >=kde-base/qimageblitz-0.0.4" 45 >=kde-base/qimageblitz-0.0.4
49 RDEPEND="${RDEPEND} >=kde-base/qimageblitz-0.0.4" 46 "
47 RDEPEND="${RDEPEND}
48 >=kde-base/qimageblitz-0.0.4
49 "
50 ;;
51 kdenetwork)
52 DEPEND="${DEPEND}
53 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
54 "
55 RDEPEND="${RDEPEND}
56 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
57 "
50 ;; 58 ;;
51 kdepim) 59 kdepim)
52 DEPEND="${DEPEND} dev-libs/boost app-office/akonadi-server" 60 DEPEND="${DEPEND}
53 RDEPEND="${RDEPEND} dev-libs/boost" 61 dev-libs/boost
54 if [[ $PN != kode ]]; then 62 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
55 DEPEND="${DEPEND} >=kde-base/kode-${PV}:${SLOT}" 63 "
56 RDEPEND="${RDEPEND} >=kde-base/kode-${PV}:${SLOT}" 64 RDEPEND="${RDEPEND}
57 fi 65 dev-libs/boost
66 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
67 "
58 case ${PN} in 68 case ${PN} in
59 akregator|kaddressbook|kjots|kmail|kmobiletools|knode|knotes|korganizer|ktimetracker) 69 akregator|kaddressbook|kjots|kmail|kmobiletools|knode|knotes|korganizer|ktimetracker)
60 IUSE="+kontact" 70 IUSE="+kontact"
71 RDEPEND="${RDEPEND}
61 DEPEND="${DEPEND} kontact? ( >=kde-base/kontactinterfaces-${PV}:${SLOT} )" 72 kontact? ( >=kde-base/kontactinterfaces-${PV}:${SLOT}[kdeprefix=] )
62 RDEPEND="${RDEPEND} kontact? ( >=kde-base/kontactinterfaces-${PV}:${SLOT} )" 73 "
63 ;; 74 ;;
64 esac 75 esac
65 ;; 76 ;;
66 kdegames) 77 kdegames)
67 if [[ $PN != libkdegames ]]; then 78 if [[ ${PN} != libkdegames ]]; then
68 DEPEND="${DEPEND} >=kde-base/libkdegames-${PV}:${SLOT}" 79 DEPEND="${DEPEND}
69 RDEPEND="${RDEPEND} >=kde-base/libkdegames-${PV}:${SLOT}" 80 >=kde-base/libkdegames-${PV}:${SLOT}[kdeprefix=]
81 "
82 RDEPEND="${RDEPEND}
83 >=kde-base/libkdegames-${PV}:${SLOT}[kdeprefix=]
84 "
70 fi 85 fi
71 ;; 86 ;;
72 koffice) 87 koffice)
73 case ${PV} in 88 [[ ${PN} != koffice-data ]] && IUSE="debug"
74 9999*) DEPEND="${DEPEND} !app-office/${PN}:2" ;;
75 1.9*|2*) DEPEND="${DEPEND} !app-office/${PN}:live" ;;
76 esac
77 DEPEND="${DEPEND} 89 RDEPEND="${RDEPEND}
90 !kdeprefix? (
78 !app-office/${PN}:0 91 !app-office/${PN}:0
79 !app-office/koffice:0 92 !app-office/koffice:0
80 !app-office/koffice-meta:0" 93 !app-office/koffice-meta:0
81 case ${PN} in
82 koffice-data)
83 DEPEND="${DEPEND} media-libs/lcms"
84 RDEPEND="${RDEPEND} media-libs/lcms"
85 ;;
86 *) 94 )
87 IUSE="+crypt" 95 "
88 DEPEND="${DEPEND} crypt? ( >=app-crypt/qca-2 )" 96 COMMON_DEPEND="
89 RDEPEND="${RDEPEND} crypt? ( >=app-crypt/qca-2 )" 97 dev-cpp/eigen:2
90 if [[ $PN != koffice-libs ]]; then 98 media-gfx/imagemagick[openexr?]
99 media-libs/fontconfig
100 media-libs/freetype:2
101 "
102 DEPEND="${DEPEND} ${COMMON_DEPEND}"
103 RDEPEND="${RDEPEND} ${COMMON_DEPEND}"
104 unset COMMON_DEPEND
105 if [[ ${PN} != koffice-libs && ${PN} != koffice-data ]]; then
106 DEPEND="${DEPEND}
91 DEPEND="${DEPEND} >=app-office/koffice-libs-${PV}:${SLOT}" 107 >=app-office/koffice-libs-${PV}:${SLOT}
108 "
109 RDEPEND="${RDEPEND}
92 RDEPEND="${RDEPEND} >=app-office/koffice-libs-${PV}:${SLOT}" 110 >=app-office/koffice-libs-${PV}:${SLOT}
111 "
93 fi 112 fi
113 ;;
114esac
115
116debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies"
117debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies"
118
119# Useful to build kde4-meta style stuff from extragear/playground (plasmoids etc)
120case ${BUILD_TYPE} in
121 live)
122 case ${KMNAME} in
123 extragear*|playground*)
124 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
125 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
94 ;; 126 ;;
95 esac 127 esac
96 ;; 128 ;;
97esac 129esac
98
99debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies"
100debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies"
101 130
102# @ECLASS-VARIABLE: KMNAME 131# @ECLASS-VARIABLE: KMNAME
103# @DESCRIPTION: 132# @DESCRIPTION:
104# Name of the parent-module (e.g. kdebase, kdepim, ...). You _must_ set it 133# Name of the parent-module (e.g. kdebase, kdepim, ...). You _must_ set it
105# _before_ inheriting this eclass, (unlike the other parameters), since it's 134# _before_ inheriting this eclass, (unlike the other parameters), since it's
118# If set to "true", $KMMODULE doesn't have to be defined. 147# If set to "true", $KMMODULE doesn't have to be defined.
119# 148#
120# Example usage: If you're installing subdirectories of a package, like plugins, 149# Example usage: If you're installing subdirectories of a package, like plugins,
121# you mark the top subdirectory (containing the package) as $KMEXTRACTONLY, and 150# you mark the top subdirectory (containing the package) as $KMEXTRACTONLY, and
122# set KMNOMODULE="true". 151# set KMNOMODULE="true".
123if [[ -z $KMMODULE && $KMNOMODULE != true ]]; then 152if [[ -z ${KMMODULE} && ${KMNOMODULE} != true ]]; then
124 KMMODULE=$PN 153 KMMODULE=${PN}
125fi 154fi
126 155
127# @ECLASS-VARIABLE: KMEXTRA 156# @ECLASS-VARIABLE: KMEXTRA
128# @DESCRIPTION: 157# @DESCRIPTION:
129# All subdirectories listed here will be extracted, compiled & installed. 158# All subdirectories listed here will be extracted, compiled & installed.
151# @FUNCTION: kde4-meta_pkg_setup 180# @FUNCTION: kde4-meta_pkg_setup
152# @DESCRIPTION: 181# @DESCRIPTION:
153# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in 182# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in
154# split ebuilds. 183# split ebuilds.
155kde4-meta_pkg_setup() { 184kde4-meta_pkg_setup() {
185 debug-print-function ${FUNCNAME} "$@"
186
156 kde4-base_pkg_setup 187 kde4-base_pkg_setup
157} 188}
158 189
159# @FUNCTION: kde4-meta_src_unpack 190# @FUNCTION: kde4-meta_src_unpack
160# @DESCRIPTION: 191# @DESCRIPTION:
161# This function unpacks the source for split ebuilds. See also 192# This function unpacks the source for split ebuilds. See also
162# kde4-meta-src_extract. 193# kde4-meta-src_extract.
163kde4-meta_src_unpack() { 194kde4-meta_src_unpack() {
164 debug-print-function ${FUNCNAME} "$@" 195 debug-print-function ${FUNCNAME} "$@"
196
165 if [[ $BUILD_TYPE = live ]]; then 197 if [[ ${BUILD_TYPE} = live ]]; then
166 migrate_store_dir 198 migrate_store_dir
167 S="${WORKDIR}/${PN}-${PV}" 199 S="${WORKDIR}/${P}"
168 mkdir -p "${S}" 200 mkdir -p "${S}"
169 ESVN_RESTRICT="export" subversion_src_unpack 201 ESVN_RESTRICT="export" subversion_src_unpack
170 subversion_wc_info 202 subversion_wc_info
171 subversion_bootstrap 203 subversion_bootstrap
172 kde4-meta_src_extract 204 kde4-meta_src_extract
181# @DESCRIPTION: 213# @DESCRIPTION:
182# A function to unpack the source for a split KDE ebuild. 214# A function to unpack the source for a split KDE ebuild.
183# Also see KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY and 215# Also see KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY and
184# KMTARPARAMS. 216# KMTARPARAMS.
185kde4-meta_src_extract() { 217kde4-meta_src_extract() {
218 debug-print-function ${FUNCNAME} "$@"
219
186 if [[ $BUILD_TYPE = live ]]; then 220 if [[ ${BUILD_TYPE} = live ]]; then
187 local rsync_options subdir kmnamedir targetdir 221 local rsync_options subdir kmnamedir targetdir
188 # Export working copy to ${S} 222 # Export working copy to ${S}
189 einfo "Exporting parts of working copy to ${S}" 223 einfo "Exporting parts of working copy to ${S}"
190 kde4-meta_create_extractlists 224 kde4-meta_create_extractlists
191 225
199 rsync --recursive ${rsync_options} "${ESVN_WC_PATH}/${kmnamedir}cmake" "${S}" \ 233 rsync --recursive ${rsync_options} "${ESVN_WC_PATH}/${kmnamedir}cmake" "${S}" \
200 || die "${ESVN}: can't export cmake files to '${S}'." 234 || die "${ESVN}: can't export cmake files to '${S}'."
201 fi 235 fi
202 # Copy all subdirectories 236 # Copy all subdirectories
203 for subdir in $(__list_needed_subdirectories); do 237 for subdir in $(__list_needed_subdirectories); do
204 targetdir="" 238 targetdir=""
205 if [[ $subdir = doc/* && ! -e "$ESVN_WC_PATH/$kmnamedir$subdir" ]]; then 239 if [[ $subdir = doc/* && ! -e "$ESVN_WC_PATH/$kmnamedir$subdir" ]]; then
206 continue 240 continue
207 fi 241 fi
208 242
209 [[ ${subdir%/} = */* ]] && targetdir=${subdir%/} && targetdir=${targetdir%/*} && mkdir -p "${S}/${targetdir}" 243 [[ ${subdir%/} = */* ]] && targetdir=${subdir%/} && targetdir=${targetdir%/*} && mkdir -p "${S}/${targetdir}"
210 rsync --recursive ${rsync_options} "${ESVN_WC_PATH}/${kmnamedir}${subdir%/}" "${S}/${targetdir}" \ 244 rsync --recursive ${rsync_options} "${ESVN_WC_PATH}/${kmnamedir}${subdir%/}" "${S}/${targetdir}" \
211 || die "${ESVN}: can't export subdirectory '${subdir}' to '${S}/${targetdir}'." 245 || die "${ESVN}: can't export subdirectory '${subdir}' to '${S}/${targetdir}'."
212 done 246 done
213 247
214 if [[ $KMNAME = kdebase-runtime && $PN != kdebase-data ]]; then 248 if [[ ${KMNAME} = kdebase-runtime && ${PN} != kdebase-data ]]; then
215 sed -i -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \ 249 sed -i -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \
216 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed" 250 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
217 fi 251 fi
218 else 252 else
219 local abort tarball tarfile f extractlist 253 local abort tarball tarfile f extractlist moduleprefix postfix
220 case $KMNAME in 254 case ${PV} in
221 kdebase-apps) 255 4.2.85)
222 tarball="${KMNAME#-apps}-${PV}.tar.bz2" 256 # block for normally packed upstream unstable snapshots
257 KMTARPARAMS="${KMTARPARAMS} --bzip2" # bz2
258 postfix="bz2"
259 ;;
260 4.2.9* | 4.2.8* | 4.2.7* | 4.2.6*)
261 KMTARPARAMS="${KMTARPARAMS} --lzma" # lzma
262 postfix="lzma"
223 ;; 263 ;;
224 *) 264 *)
225 tarball="${KMNAME}-${PV}.tar.bz2" 265 KMTARPARAMS="${KMTARPARAMS} --bzip2" # bz2
266 postfix="bz2"
226 ;; 267 ;;
227 esac 268 esac
269 case ${KMNAME} in
270 kdebase-apps)
271 # kdebase/apps -> kdebasa-apps
272 tarball="kdebase-${PV}.tar.${postfix}"
273 # Go one level deeper for kdebase-apps in tarballs
274 moduleprefix=apps/
275 KMTARPARAMS="${KMTARPARAMS} --transform=s|apps/||"
276 ;;
277 *)
278 # Create tarball name from module name (this is the default)
279 tarball="${KMNAME}-${PV}.tar.${postfix}"
280 ;;
281 esac
282
283 # Full patch to source tarball
228 tarfile="${DISTDIR}"/${tarball} 284 tarfile="${DISTDIR}/${tarball}"
285
286 # Detect real toplevel dir from tarball name - it will be used upon extraction
287 # and in __list_needed_subdirectories
288 topdir="${tarball%.tar.*}/"
229 289
230 ebegin "Unpacking parts of ${tarball} to ${WORKDIR}" 290 ebegin "Unpacking parts of ${tarball} to ${WORKDIR}"
231 291
232 kde4-meta_create_extractlists 292 kde4-meta_create_extractlists
233 293
234 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake \ 294 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake \
235 AUTHORS COPYING INSTALL README NEWS ChangeLog 295 AUTHORS COPYING INSTALL README NEWS ChangeLog
236 do 296 do
237 extractlist="${extractlist} ${KMNAME}-${PV}/${f}" 297 extractlist="${extractlist} ${topdir}${moduleprefix}${f}"
238 done 298 done
239 extractlist="${extractlist} $(__list_needed_subdirectories)" 299 extractlist="${extractlist} $(__list_needed_subdirectories)"
240 KMTARPARAMS="${KMTARPARAMS} -j"
241 300
242 pushd "${WORKDIR}" > /dev/null 301 pushd "${WORKDIR}" > /dev/null
243 [[ -n ${KDE4_STRICTER} ]] && echo tar -xpf $tarfile $KMTARPARAMS $extractlist >&2 302 [[ -n ${KDE4_STRICTER} ]] && echo tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} >&2
244 tar -xpf $tarfile $KMTARPARAMS $extractlist 2> /dev/null 303 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} 2> /dev/null
245 304
246 # Default $S is based on $P; rename the extracted directory to match $S 305 # Default $S is based on $P; rename the extracted directory to match $S if necessary
247 mv ${KMNAME}-${PV} ${P} || die "Died while moving \"${KMNAME}-${PV}\" to \"${P}\"" 306 mv ${topdir} ${P} || die "Died while moving \"${topdir}\" to \"${P}\""
248 307
249 popd > /dev/null 308 popd > /dev/null
250 309
251 eend $? 310 eend $?
311
312 # We need to clear it here to make verification below work
313 unset moduleprefix
252 314
253 if [[ -n ${KDE4_STRICTER} ]]; then 315 if [[ -n ${KDE4_STRICTER} ]]; then
254 for f in $(__list_needed_subdirectories fatal); do 316 for f in $(__list_needed_subdirectories fatal); do
255 if [[ ! -e ${S}/${f#*/} ]]; then 317 if [[ ! -e "${S}/${f#*/}" ]]; then
256 eerror "'${f#*/}' is missing" 318 eerror "'${f#*/}' is missing"
257 abort=true 319 abort=true
258 fi 320 fi
259 done 321 done
260 [[ -n ${abort} ]] && die "There were missing files." 322 [[ -n ${abort} ]] && die "There were missing files."
261 fi 323 fi
262 kde4-base_src_unpack 324
263 fi 325 # We don't need it anymore
264 # fix koffice linking 326 unset topdir
265 if [[ $KMNAME = koffice ]]; then
266 koffice_fix_libraries
267 fi 327 fi
268} 328}
269 329
270# @FUNCTION: kde4-meta_create_extractlists 330# @FUNCTION: kde4-meta_create_extractlists
271# @DESCRIPTION: 331# @DESCRIPTION:
273# Also see descriptions of KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, 333# Also see descriptions of KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY,
274# KMEXTRACTONLY and KMTARPARAMS. 334# KMEXTRACTONLY and KMTARPARAMS.
275kde4-meta_create_extractlists() { 335kde4-meta_create_extractlists() {
276 debug-print-function ${FUNCNAME} "$@" 336 debug-print-function ${FUNCNAME} "$@"
277 337
278 if has htmlhandbook ${IUSE//+} && use htmlhandbook; then 338 # TODO change to KMEXTRA for more strict check
339 if has doc ${IUSE//+} && use doc && [[ -n ${KMMODULE} ]]; then
279 # We use the basename of $KMMODULE because $KMMODULE can contain 340 # We use the basename of $KMMODULE because $KMMODULE can contain
280 # the path to the module subdirectory. 341 # the path to the module subdirectory.
281 KMEXTRA_NONFATAL="${KMEXTRA_NONFATAL} doc/${KMMODULE##*/}" 342 KMEXTRA_NONFATAL="${KMEXTRA_NONFATAL} doc/${KMMODULE##*/}"
282 fi 343 fi
283 344
303 KMEXTRACTONLY="${KMEXTRACTONLY} 364 KMEXTRACTONLY="${KMEXTRACTONLY}
304 config-unix.h.cmake 365 config-unix.h.cmake
305 ConfigureChecks.cmake 366 ConfigureChecks.cmake
306 config-workspace.h.cmake 367 config-workspace.h.cmake
307 config-X11.h.cmake 368 config-X11.h.cmake
308 startkde.cmake" 369 startkde.cmake
309 case ${SLOT} in
310 4.2)
311 KMEXTRACTONLY="${KMEXTRACTONLY}
312 KDE4WorkspaceConfig.cmake.in" 370 KDE4WorkspaceConfig.cmake.in"
313 ;;
314 *) : ;;
315 esac
316 ;; 371 ;;
317 kdegames) 372 kdegames)
318 if [[ ${PN} != "libkdegames" ]]; then 373 if [[ ${PN} != libkdegames ]]; then
319 KMEXTRACTONLY="${KMEXTRACTONLY} 374 KMEXTRACTONLY="${KMEXTRACTONLY}
320 libkdegames" 375 libkdegames"
321 fi 376 fi
322 ;; 377 ;;
323 kdepim) 378 kdepim)
379 if [[ ${PN} != libkdepim ]]; then
380 KMEXTRACTONLY="${KMEXTRACTONLY}
381 libkdepim"
382 fi
383 case ${SLOT} in
384 4.3|live)
385 KMEXTRACTONLY="${KMEXTRACTONLY}
386 kdepim-version.h
387 config-enterprise.h.cmake"
388 ;;
389 esac
324 KMEXTRACTONLY="${KMEXTRACTONLY} 390 KMEXTRACTONLY="${KMEXTRACTONLY}
325 kleopatra/ConfigureChecks.cmake 391 kleopatra/ConfigureChecks.cmake"
326 libkdepim/kdepim_export.h"
327 if has kontact ${IUSE//+} && use kontact; then 392 if has kontact ${IUSE//+} && use kontact; then
328 KMEXTRA="${KMEXTRA} kontact/plugins/${PLUGINNAME:-${PN}}" 393 KMEXTRA="${KMEXTRA} kontact/plugins/${PLUGINNAME:-${PN}}"
329 KMEXTRACTONLY="${KMEXTRACTONLY} kontactinterfaces/" 394 KMEXTRACTONLY="${KMEXTRACTONLY} kontactinterfaces/"
330 fi 395 fi
331 ;; 396 ;;
335 filters/config-filters.h.cmake 400 filters/config-filters.h.cmake
336 config-openctl.h.cmake 401 config-openctl.h.cmake
337 config-openexr.h.cmake 402 config-openexr.h.cmake
338 config-opengl.h.cmake 403 config-opengl.h.cmake
339 config-prefix.h.cmake" 404 config-prefix.h.cmake"
340 case ${PN} in
341 koffice-libs|koffice-data)
342 ;;
343 *)
344 # add basic extract for all packages
345 KMEXTRACTONLY="${KMEXTRACTONLY}
346 filters/
347 libs/
348 plugins/"
349 if [[ ${PN} != "kplato" ]]; then
350 KMEXTRA="${KMEXTRA} filters/${PN}"
351 fi
352 ;;
353 esac
354 ;; 405 ;;
355 esac 406 esac
356 # Don't install cmake modules for split ebuilds, to avoid collisions. 407 # Don't install cmake modules for split ebuilds, to avoid collisions.
357 case ${KMNAME} in 408 case ${KMNAME} in
358 kdebase-runtime|kdebase-workspace|kdeedu|kdegames|kdegraphics|kdepim) 409 kdebase-runtime|kdebase-workspace|kdeedu|kdegames|kdegraphics|kdepim)
359 case ${PN} in 410 case ${PN} in
360 libkdegames|libkdeedu|marble|libkworkspace) 411 libkdegames|libkdeedu|libkworkspace)
361 KMEXTRA="${KMEXTRA} 412 KMEXTRA="${KMEXTRA}
362 cmake/modules/" 413 cmake/modules/"
363 ;; 414 ;;
364 *) 415 *)
365 KMCOMPILEONLY="${KMCOMPILEONLY} 416 KMCOMPILEONLY="${KMCOMPILEONLY}
371 422
372 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME}: KMEXTRACTONLY ${KMEXTRACTONLY}" 423 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME}: KMEXTRACTONLY ${KMEXTRACTONLY}"
373} 424}
374 425
375__list_needed_subdirectories() { 426__list_needed_subdirectories() {
376 local i j kmextra kmextra_expanded kmmodule_expanded kmcompileonly_expanded extractlist topdir 427 local i j kmextra kmextra_expanded kmmodule_expanded kmcompileonly_expanded extractlist
377 428
378 # We expand KMEXTRA by adding CMakeLists.txt files 429 # We expand KMEXTRA by adding CMakeLists.txt files
379 kmextra="${KMEXTRA}" 430 kmextra="${KMEXTRA}"
380 [[ ${1} != fatal ]] && kmextra="${kmextra} ${KMEXTRA_NONFATAL}" 431 [[ ${1} != fatal ]] && kmextra="${kmextra} ${KMEXTRA_NONFATAL}"
381 for i in ${kmextra}; do 432 for i in ${kmextra}; do
386 j=$(dirname ${j}) 437 j=$(dirname ${j})
387 done 438 done
388 done 439 done
389 440
390 # Expand KMMODULE 441 # Expand KMMODULE
391 if [[ -n $KMMODULE ]]; then 442 if [[ -n ${KMMODULE} ]]; then
392 kmmodule_expanded="${KMMODULE}" 443 kmmodule_expanded="${KMMODULE}"
393 j=$(dirname ${KMMODULE}) 444 j=$(dirname ${KMMODULE})
394 while [[ ${j} != "." ]]; do 445 while [[ ${j} != "." ]]; do
395 kmmodule_expanded="${kmmodule_expanded} $j/CMakeLists.txt"; 446 kmmodule_expanded="${kmmodule_expanded} ${j}/CMakeLists.txt";
396 j=$(dirname $j) 447 j=$(dirname ${j})
397 done 448 done
398 fi 449 fi
399 450
400 # Expand KMCOMPILEONLY 451 # Expand KMCOMPILEONLY
401 for i in ${KMCOMPILEONLY}; do 452 for i in ${KMCOMPILEONLY}; do
409 460
410 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmextra_expanded: ${kmextra_expanded}" 461 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmextra_expanded: ${kmextra_expanded}"
411 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmmodule_expanded: ${kmmodule_expanded}" 462 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmmodule_expanded: ${kmmodule_expanded}"
412 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmcompileonly_expanded: ${kmcompileonly_expanded}" 463 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmcompileonly_expanded: ${kmcompileonly_expanded}"
413 464
414
415 case ${PV} in
416 scm|9999*) : ;;
417 *) topdir="${KMNAME}-${PV}/" ;;
418 esac
419
420 # Create final list of stuff to extract 465 # Create final list of stuff to extract
466 # We append topdir only when specified (usually for tarballs)
421 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \ 467 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \
422 ${KMEXTRACTONLY} 468 ${KMEXTRACTONLY}
423 do 469 do
424 extractlist="${extractlist} ${topdir}${i}" 470 extractlist="${extractlist} ${topdir}${moduleprefix}${i}"
425 done 471 done
426 472
427 echo ${extractlist} 473 echo ${extractlist}
428} 474}
429 475
434 debug-print-function ${FUNCNAME} "$@" 480 debug-print-function ${FUNCNAME} "$@"
435 481
436 kde4-meta_change_cmakelists 482 kde4-meta_change_cmakelists
437 kde4-base_src_prepare 483 kde4-base_src_prepare
438} 484}
439
440 485
441# FIXME: no comment here? 486# FIXME: no comment here?
442_change_cmakelists_parent_dirs() { 487_change_cmakelists_parent_dirs() {
443 debug-print-function ${FUNCNAME} "$@" 488 debug-print-function ${FUNCNAME} "$@"
444 489
458 503
459# FIXME: add description 504# FIXME: add description
460# @FUNCTION: kde4-meta_change_cmakelists 505# @FUNCTION: kde4-meta_change_cmakelists
461# @DESCRIPTION: 506# @DESCRIPTION:
462kde4-meta_change_cmakelists() { 507kde4-meta_change_cmakelists() {
463 debug-print-function ${FUNCNAME} "$@" 508 debug-print-function ${FUNCNAME} "$@"
464 509
465 pushd "${S}" > /dev/null 510 pushd "${S}" > /dev/null
466 511
467 comment_all_add_subdirectory ./ 512 comment_all_add_subdirectory ./
468 513
478 find "${S}"/${KMMODULE} -name CMakeLists.txt -print0 | xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \ 523 find "${S}"/${KMMODULE} -name CMakeLists.txt -print0 | xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
479 die "${LINENO}: died in KMMODULE section" 524 die "${LINENO}: died in KMMODULE section"
480 _change_cmakelists_parent_dirs ${KMMODULE} 525 _change_cmakelists_parent_dirs ${KMMODULE}
481 fi 526 fi
482 527
528 local i
529
530 # KMEXTRACTONLY section - Some ebuilds need to comment out some subdirs in KMMODULE and they use KMEXTRACTONLY
531 for i in ${KMEXTRACTONLY}; do
532 if [[ -d "${S}"/${i} && -f "${S}"/${i}/../CMakeLists.txt ]]; then
533 sed -i -e "/([[:space:]]*$(basename $i)[[:space:]]*)/s/^/#DONOTCOMPILE /" "${S}"/${i}/../CMakeLists.txt || \
534 die "${LINENO}: sed died while working in the KMEXTRACTONLY section while processing ${i}"
535 fi
536 done
537
483 # KMCOMPILEONLY 538 # KMCOMPILEONLY
484 local i
485 for i in ${KMCOMPILEONLY}; do 539 for i in ${KMCOMPILEONLY}; do
486 debug-print "${LINENO}: KMCOMPILEONLY, processing ${i}" 540 debug-print "${LINENO}: KMCOMPILEONLY, processing ${i}"
487 # Uncomment "add_subdirectory" instructions inside $KMCOMPILEONLY, then comment "install" instructions. 541 # Uncomment "add_subdirectory" instructions inside $KMCOMPILEONLY, then comment "install" instructions.
488 find "${S}"/${i} -name CMakeLists.txt -print0 | \ 542 find "${S}"/${i} -name CMakeLists.txt -print0 | \
489 xargs -0 sed -i \ 543 xargs -0 sed -i \
511 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}" 565 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}"
512 _change_cmakelists_parent_dirs ${i} 566 _change_cmakelists_parent_dirs ${i}
513 fi 567 fi
514 done 568 done
515 569
516 # KMEXTRACTONLY section - Some ebuilds need to comment out some subdirs in KMMODULE and they use KMEXTRACTONLY
517 for i in ${KMEXTRACTONLY}; do
518 if [[ -d "${S}"/${i} && -f "${S}"/${i}/../CMakeLists.txt ]]; then
519 sed -i -e "/([[:space:]]*$(basename $i)[[:space:]]*)/s/^/#DONOTCOMPILE /" "${S}"/${i}/../CMakeLists.txt || \
520 die "${LINENO}: sed died while working in the KMEXTRACTONLY section while processing ${i}"
521 fi
522 done
523
524 case ${KMNAME} in 570 case ${KMNAME} in
525 kdebase-workspace) 571 kdebase-workspace)
526 # COLLISION PROTECT section 572 # COLLISION PROTECT section
527 # Install the startkde script just once, as a part of kde-base/kdebase-startkde, 573 # Install the startkde script just once, as a part of kde-base/kdebase-startkde,
528 # not as a part of every package. 574 # not as a part of every package.
529 if [[ ${PN} != "kdebase-startkde" && -f "${S}"/CMakeLists.txt ]]; then 575 if [[ ${PN} != kdebase-startkde && -f "${S}"/CMakeLists.txt ]]; then
530 # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0. 576 # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0.
531 sed -i -e '/startkde/s/^/#DONOTINSTALL /' "${S}"/CMakeLists.txt || \ 577 sed -i -e '/startkde/s/^/#DONOTINSTALL /' "${S}"/CMakeLists.txt || \
532 die "${LINENO}: sed died in the kdebase-startkde collision prevention section" 578 die "${LINENO}: sed died in the kdebase-startkde collision prevention section"
533 fi 579 fi
534 # Strip EXPORT feature section from workspace for KDE4 versions > 4.1.82 580 # Strip EXPORT feature section from workspace for KDE4 versions > 4.1.82
535 if [[ ${SLOT} == 4.2 ]] || [[ ${PV} == 9999 ]]; then
536 if [[ ${PN} != libkworkspace ]]; then 581 if [[ ${PN} != libkworkspace ]]; then
537 sed -i -e '/install(FILES ${CMAKE_CURRENT_BINARY_DIR}\/KDE4WorkspaceConfig.cmake/,/^[[:space:]]*FILE KDE4WorkspaceLibraryTargets.cmake )[[:space:]]*^/d' \ 582 sed -i -e '/install(FILES ${CMAKE_CURRENT_BINARY_DIR}\/KDE4WorkspaceConfig.cmake/,/^[[:space:]]*FILE KDE4WorkspaceLibraryTargets.cmake )[[:space:]]*^/d' \
538 CMakeLists.txt || die "${LINENO}: sed died in kdebase-workspace strip EXPORT section" 583 CMakeLists.txt || die "${LINENO}: sed died in kdebase-workspace strip EXPORT section"
539 fi
540 fi 584 fi
541 ;; 585 ;;
542 kdebase-runtime) 586 kdebase-runtime)
543 # COLLISION PROTECT section 587 # COLLISION PROTECT section
544 # Only install the kde4 script as part of kde-base/kdebase-data 588 # Only install the kde4 script as part of kde-base/kdebase-data
545 if [[ ${PN} != "kdebase-data" && -f "${S}"/CMakeLists.txt ]]; then 589 if [[ ${PN} != kdebase-data && -f "${S}"/CMakeLists.txt ]]; then
546 sed -i -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \ 590 sed -i -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \
547 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed" 591 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
548 fi 592 fi
549 ;; 593 ;;
550 kdepim) 594 kdepim)
554 -e '/add_custom_target(kmail_xml /,/)/p' "${S}"/kmail/CMakeLists.txt || die "uncommenting xml failed" 598 -e '/add_custom_target(kmail_xml /,/)/p' "${S}"/kmail/CMakeLists.txt || die "uncommenting xml failed"
555 _change_cmakelists_parent_dirs kmail 599 _change_cmakelists_parent_dirs kmail
556 ;; 600 ;;
557 esac 601 esac
558 ;; 602 ;;
603 kdewebdev)
604 # Disable hardcoded kdepimlibs check
605 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
606 -e 's/find_package(LibXml2 REQUIRED)/macro_optional_find_package(LibXml2 REQUIRED)/' \
607 -e 's/find_package(LibXslt REQUIRED)/macro_optional_find_package(LibXslt REQUIRED)/' \
608 -e 's/find_package(Boost REQUIRED)/macro_optional_find_package(Boost REQUIRED)/' \
609 -i CMakeLists.txt || die "failed to disable hardcoded checks"
610 ;;
611 koffice)
612 # prevent collisions
613 if [[ ${PN} != koffice-data ]]; then
614 sed -i -e '/install(.*FindKOfficeLibs.cmake/,/)/ d' \
615 "${S}"/cmake/modules/CMakeLists.txt || \
616 die "${LINENO}: sed died in collision prevention section"
617 sed -i -n -e '1h;1!H;${g;s/install(.\+config-openexr.h.\+)//;p}' \
618 "${S}"/CMakeLists.txt || \
619 die "${LINENO}: sed died in collision prevention section"
620 fi
559 esac 621 esac
560 622
561 popd > /dev/null 623 popd > /dev/null
562} 624}
563 625
564# @FUNCTION: kde4-meta_src_configure 626# @FUNCTION: kde4-meta_src_configure
565# @DESCRIPTION: 627# @DESCRIPTION:
566# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in split 628# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in split
567# ebuilds. 629# ebuilds.
568kde4-meta_src_configure() { 630kde4-meta_src_configure() {
569 debug-print-function ${FUNCNAME} "$@" 631 debug-print-function ${FUNCNAME} "$@"
632
633 # Set some cmake default values here (usually workarounds for automagic deps)
634 case ${KMNAME} in
635 kdewebdev)
636 mycmakeargs="
637 -DWITH_KdepimLibs=OFF
638 -DWITH_LibXml2=OFF
639 -DWITH_LibXslt=OFF
640 -DWITH_Boost=OFF
641 -DWITH_LibTidy=OFF
642 ${mycmakeargs}"
643 ;;
644 esac
570 645
571 kde4-base_src_configure 646 kde4-base_src_configure
572} 647}
573 648
574# @FUNCTION: kde4-meta_src_compile 649# @FUNCTION: kde4-meta_src_compile
575# @DESCRIPTION: 650# @DESCRIPTION:
576# General function for compiling split KDE4 applications. 651# General function for compiling split KDE4 applications.
577# Overrides kde4-base_src_compile. 652# Overrides kde4-base_src_compile.
578kde4-meta_src_compile() { 653kde4-meta_src_compile() {
579 debug-print-function ${FUNCNAME} "$@" 654 debug-print-function ${FUNCNAME} "$@"
580 655
581 kde4-base_src_make 656 kde4-base_src_compile
582} 657}
583 658
584# @FUNCTION: kde4-meta_src_test 659# @FUNCTION: kde4-meta_src_test
585# @DESCRIPTION: 660# @DESCRIPTION:
586# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 661# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split
595# @DESCRIPTION: 670# @DESCRIPTION:
596# Function for installing KDE4 split applications. 671# Function for installing KDE4 split applications.
597kde4-meta_src_install() { 672kde4-meta_src_install() {
598 debug-print-function $FUNCNAME "$@" 673 debug-print-function $FUNCNAME "$@"
599 674
600 kde4-meta_src_make_doc 675 kde4-base_src_install
601 cmake-utils_src_install
602
603 if [[ -n ${KMSAVELIBS} ]]; then
604 install_library_dependencies
605 fi
606
607 # remove unvanted koffice stuff
608 if [[ $KMNAME = koffice && $PN != koffice-data ]]; then
609 rm "$D/$KDEDIR/include/config-openexr.h"
610 rm "$D/$KDEDIR/share/apps/cmake/modules/FindKOfficeLibs.cmake"
611 fi
612} 676}
613 677
614# @FUNCTION: kde4-meta_src_make_doc 678# @FUNCTION: kde4-meta_src_make_doc
615# @DESCRIPTION: 679# @DESCRIPTION:
616# This function searches in ${S}/${KMMODULE}, 680# This function searches in ${S}/${KMMODULE},
617# and tries to install "AUTHORS ChangeLog* README* NEWS todo" if these files exist. 681# and tries to install "AUTHORS ChangeLog* README* NEWS todo" if these files exist.
618kde4-meta_src_make_doc() { 682kde4-meta_src_make_doc() {
619 debug-print-function $FUNCNAME "$@" 683 debug-print-function ${FUNCNAME} "$@"
620 684
621 local doc 685 local doc
622 for doc in AUTHORS ChangeLog* README* NEWS TODO; do 686 for doc in AUTHORS ChangeLog* README* NEWS TODO; do
623 [[ -s ${KMMODULE}/$doc ]] && newdoc "${KMMODULE}/${doc}" "${doc}.${KMMODULE##*/}" 687 [[ -s ${KMMODULE}/${doc} ]] && newdoc "${KMMODULE}/${doc}" "${doc}.${KMMODULE##*/}"
624 done 688 done
625 689
626 kde4-base_src_make_doc 690 kde4-base_src_make_doc
627} 691}
628 692
629# @FUNCTION: kde4-meta_pkg_postinst 693# @FUNCTION: kde4-meta_pkg_postinst
630# @DESCRIPTION: 694# @DESCRIPTION:
631# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 695# Display information about application handbook and invoke kbuildsycoca4.
632# ebuilds.
633kde4-meta_pkg_postinst() { 696kde4-meta_pkg_postinst() {
697 debug-print-function ${FUNCNAME} "$@"
698
699 if has doc ${IUSE//+} && ! use doc; then
700 echo
701 einfo "Application handbook for ${PN} has not been installed."
702 einfo "To install handbook, reemerge =${CATEGORY}/${P} with 'doc' USE flag."
703 echo
704 fi
705
634 kde4-base_pkg_postinst 706 kde4-base_pkg_postinst
635} 707}
636 708
637# @FUNCTION: kde4-meta_pkg_postrm 709# @FUNCTION: kde4-meta_pkg_postrm
638# @DESCRIPTION: 710# @DESCRIPTION:
639# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 711# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split
640# ebuilds. 712# ebuilds.
641kde4-meta_pkg_postrm() { 713kde4-meta_pkg_postrm() {
714 debug-print-function ${FUNCNAME} "$@"
715
642 kde4-base_pkg_postrm 716 kde4-base_pkg_postrm
643} 717}
644

Legend:
Removed from v.1.10  
changed lines
  Added in v.1.18

  ViewVC Help
Powered by ViewVC 1.1.20